
typedef struct _a_link {
  connect_entry *ce;                
  long link_ref;                 
} a_link;


typedef struct _object_list_ent {
  object_instance *object;
  int link_socket;                  /* where object was created/linked from */
  long link_ref;                    /* the link reference */
  long obj_ref;
  void *nodeptr;
  connect_entry *obj_connect;   
  char debug;
  char ft;
  a_link *debug_link;
  a_link *ft_link;
  int is_link;                      /* Is this entry a link? */
  int proc_id;
  long port_num;
} object_ent;


#define OBJECT  1                   /* Describes what kind of connection */
#define DEAN    2

typedef struct _connect_des {
  int type;
  int connect_id;
  int num_links;
  node_des node;
  long obj_ref;                     /* OBJ ref of the object on other end */
  connect_entry *ce;
  Nodeptr nodeptr;
} connect_des;


#define OBJECT_TIMEOUT 5             /* Timeout for connecting group */

#define OBJECT_NOT_SUPPORTED -10
#define GROUP_NOT_LOADED     -11
#define GROUP_PROTOCOL_ERROR -12


#ifdef __STDC__
int init_objects();
int launch_object(char *);
void new_connection(connect_entry *, int);
int f_new_object(command *);
int f_object_created(command *, connect_entry *);
int f_delete_object(command *);
int f_object_deleted(command *);
int f_object_load(command *, connect_entry *);
int f_object_message(command *);
int f_return_message(command *);
int f_link_object(command *);

long insert_object_list(object_instance *, long app_ref, int app_socket, long port_num);
#else
int init_objects();
int launch_object();
void new_connection();
int f_new_object();
int f_object_created();
int f_delete_object();
int f_object_deleted();
int f_object_load();
int f_object_message();
int f_return_message();
int f_link_object();
long insert_object_list();
#endif
