/* List.h
 * Jim Gochee
 * 2/6/89 
 */

#ifndef _LIST_H
#define _LIST_H
/*****************************************************************************
 *                                                                           *
 *                            Public Declarations                            *
 *                                                                           *
 *****************************************************************************/

typedef struct _node {
  struct _node *next,*prev;
  char *key,*data;
} NodeRec, *Nodeptr;

typedef struct _List {
  Nodeptr dummy,current;
  int num_nodes;
} ListRec, *List;


/*****************************************************************************
 *                                                                           *
 *                          Defined functions for speed                      *
 *                                                                           *
 *****************************************************************************/


#define EndList(a)  ((a)->current->next == (a)->dummy)


/*****************************************************************************
 *                                                                           *
 *                            Public Function Declarations                   *
 *                                                                           *
 *****************************************************************************/

#ifdef __STDC__
List CreateList(void);                   /* Create a new list */
void SetEnd(List);                       /* Set to end of list */
void SetBeginning(List);                 /* Set to beginning of list */
int SetKey(List, void *key);             /* Set to node with key = 'key' */
int SetNumber(List, int n);              /* Set to the 'n'th node */
int ReadData(List, void **, void **);    /* Read key and data from curr node */
int WriteData(List, void *, void *);     /* Writes key and data to curr node */
Nodeptr InsertData(List, void *, void *);/* Insert new node with key & data  */
void SetNext(List);                      /* Set to next node */
void SetNode(List, Nodeptr);             /* Set to a specific node */
Nodeptr GetNode(List);                   /* Get current node pointer */
void SetPrev(List);                      /* Set to prev node */
void DeleteNode(List);                   /* Delete current node */

#ifndef EndList
int EndList(List);                       /* TRUE if at end of list */
#endif

int BeginningList(List);                 /* TRUE if at beginning of list */
void FreeList(List);                     /* Deallocates list memory */
int Number(List);                        /* How many nodes in the list */

#else

int BeginningList();
List CreateList();
void DeleteNode();
void FreeList();
Nodeptr GetNode();
Nodeptr InsertData();
int Number();
int ReadData();
void SetBeginning();
void SetEnd();
int SetKey();
void SetNext();
void SetNode();
int SetNumber();
void SetPrev();
int WriteData();
#endif
#endif

