#include "List.h"

typedef struct _connections {
  List connect_list;                        /* A list of connection entries */
  int num_connections;
  fd_set fd_connect, last_connect;
  int last_index;
  int last_socket;
} connect_type;

typedef struct _connect_entry {
  node_des node;
  int the_socket;
  void *data;
} connect_entry;


#ifdef __STDC__
connect_type *new_connections(void);
connect_entry *add_connection(connect_type *, int, node_des *);
int delete_connection(connect_type *, connect_entry *);
int wait_on_connections(connect_type *, struct timeval *);
connect_entry *get_next_entry(connect_type *);
int read_c_header(connect_type *, connect_entry *);
connect_entry *accept_new_connection(connect_type *, int);
#else
connect_type *new_connections();
connect_entry *add_connection();
int delete_connection();
int wait_on_connections();
connect_entry *get_next_entry();
int read_c_header();
connect_entry *accept_new_connection();
#endif
