#define CREATE            1
#define PACK_DATASTRUCT   2
#define UNPACK_DATASTRUCT 3
#define DELETE            4


/* How to set fields of the object descriptor from the command line:
 *
 * (object name) -n <num objects>
 *               -c <class list>
 *               -f <file_name containing info>
 *               -m <machine_list>
 *
 *
 * The format for an info file is:
 * <num objects>\n
 * <class_list>\n
 * <machine_list>
 */
typedef struct {
  int num_objects;                      /* default to 0 */
  char classes[100];                    /* Default to empty string */
  int num_machines;                     /* Default to 0 */
  char **machine;                       /* Default to 0 pointer */
} object_descriptor;
  


extern int _argc;
extern char **_argv;

/* CREATE and DELETE routines */

#ifdef __STDC__
object_instance *create_object(char *machine, char *type,
			       int debug, int fault_t, int create_async);
int sync_created_objects(void);
int get_object_status(object_instance *object);
object_instance *link_object(link_des *);
object_instance *speed_link(link_des *);
int delete_object(object_instance *);

/* Messge routines */

return_info *send_obj_message(object_instance *, int message,	
			      pblock *params, int async, int wait_return);
int send_obj_mess_callback(object_instance *object, int message, parameter_block *params, void *callback, void *data);

void idle_objects(int secs, int usecs);

int init_objects(int argc, char **argv, void *object_callback);
int register_dean(void);
int get_machines(char *class, char ***machine_list);
void get_object_times(object_instance *object, double *idle, double *cpu,
		      double *writing);
void reset_times(object_instance *object);

#else
object_instance *create_object();
int sync_created_objects();
int get_object_status();
object_instance *link_object();
object_instance *speed_link();
int delete_object();
return_info *send_obj_message();
int send_obj_mess_callback();
int init_objects();
int register_dean();
int get_machines();
void get_object_times();
void reset_times();
#endif
