/* Spede.h
 *
 *
 */


#define MAX_SOCKETS   500          /* Max number of open socket connections */
#define MAX_PARAMS     20          /* Maximum number of parameters */
#define HOST_NAME_SIZE 32
#define OBJ_NAME_SIZE  20



#define ACTIVE        0x01
#define BEING_CREATED 0x02
#define BEING_MOVED   0x03
#define BEING_DELETED 0x04


#define OBJECT_OK        0
#define CREATING_OBJECT  1

#define NO_ERROR         0
#define INVALID_REMOTE   -100
#define INVALID_OBJECT   -101
#define NETWORK_ERROR    -102
#define CREATION_TIMEOUT -103


typedef char boolean;


typedef struct {
  node_des node;
  long obj_ref;
} link_des;

typedef struct {
  link_des creator;                      /* Points to who created the obj */
  link_des storesite;                    /* Points where obj is backed up */
  link_des location;                     /* Points to where obj is running */
  char type[OBJ_NAME_SIZE];
  long  id;
  boolean is_fault_tolerant;
  boolean debug;
  
  /* These variables are not sent over the wire */
  
  char state;                            /* What is the state of the object */
  void *data;                            /* Used internally */ 
  long dean_ref;
} object_instance;



typedef struct {
  void *data;                              /* A pointer to malloced memory */
  long len;
} parameter;

typedef struct {
  short num_params;
  parameter param[MAX_PARAMS];             /* An array of parameters */
} parameter_block, pblock;


typedef struct {
  long status;
  long result;
  pblock *r_params;
} return_info;

