#include <sys/time.h>
#include <sys/errno.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <stdio.h>
#include <string.h>
#include <varargs.h>
#include <utmp.h>
#include <sys/file.h>

#include "select.h"
#include "List.h"
#include "rw_sock.h"
#include "sockets.h"
#include "network.h"


connect_type *new_connections()
{
  connect_type *new_connect;

  new_connect = (connect_type *) malloc(sizeof(connect_type));
  new_connect->connect_list = CreateList();
  new_connect->num_connections = 0;
  new_connect->last_index = -1;
  new_connect->last_socket = -1;
  FD_ZERO(&new_connect->fd_connect);

  return(new_connect);
}


connect_entry *add_connection(con, socket, node)
     connect_type *con;
     int socket;
     node_des *node;
{
  connect_entry *new;

  new = (connect_entry *) malloc(sizeof(connect_entry));
  new->node = *node;
  new->the_socket = socket;
  FD_SET(socket, &con->fd_connect);
  
  SetEnd(con->connect_list);
  InsertData(con->connect_list, 0, (char *) new);
  return(new);
}


int wait_on_connections(con, ti)
     connect_type *con;
     struct timeval *ti;
{
  int nfound;

  con->last_connect = con->fd_connect;
  con->last_index = 1;
  con->last_socket = -1;
  nfound = select(FD_SETSIZE, &con->last_connect, 0, 0, ti);
  return(nfound);
}

connect_entry *get_next_entry(con)
     connect_type *con;
{
  connect_entry *ce;
  List cl = con->connect_list;
  
  SetNumber(cl, con->last_index);
  if (EndList(cl))
    return(0);
  
  while(!EndList(cl)) {
    ReadData(cl, 0, (void **) &ce);
    if (ce->the_socket == con->last_socket) {
      con->last_index++;
      SetNext(cl);
      continue;
    }
    if (FD_ISSET(ce->the_socket, &con->last_connect)) {
      con->last_socket = ce->the_socket;
      return(ce);
    }
    con->last_index++;
    SetNext(cl);
  }
  return(0);
}


int read_c_header(con, ce)
     connect_type *con;
     connect_entry *ce;
{
  int error;
  char command;

  error = read_header(ce->the_socket, &command);
  if (error) {
    delete_connection(con, ce);
    return(-1);
  }
  return(command);
}


int delete_connection(con, ce)
     connect_type *con;
     connect_entry *ce;
{
  register List cl = con->connect_list;
  connect_entry *te;

  SetBeginning(cl);
  while(!EndList(cl)) {
    ReadData(cl, 0, (void **) &te);
    if (te->the_socket == ce->the_socket) {
      close(ce->the_socket);
      FD_CLR(ce->the_socket, &con->fd_connect);
      DeleteNode(cl);
      free(ce);
      return(0);
    }
    SetNext(cl);
  }
}


connect_entry *accept_new_connection(con, world_socket)
     connect_type *con;
     int world_socket;
{
  int the_socket;
  node_des new_node;

  the_socket = accept_connection(world_socket, &new_node);
  if (the_socket <= 0) {
    return(0);
  }
  return(add_connection(con, the_socket, &new_node));
}
