/* skel.c		Jim Gochee		12/9/88 */
/* X version of CS 23 Macintosh Skel program */

static char rcsid[] = "$Header: /usr/people/gochee/paint/skel.c,v 1.4 89/02/05 14:05:25 gochee Exp $";
/* $Log:	skel.c,v $
 * Revision 1.4  89/02/05  14:05:25  gochee
 * final hand in
 * 
 * Revision 1.1  89/02/01  16:09:06  gochee
 * Initial revision
 * 
 */

#define XAW_BC

#include <stdio.h>
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Xaw/Box.h>
/*#include <X11/Xaw/VPaned.h>*/
#include <X11/Xaw/Form.h>
#include <X11/Xaw/Command.h>
#include <X11/Xaw/Label.h>

#include "skel.h"

/******  GLOBAL VARIABLES  ******/

Widget toplevel,canvas;			/* main application widget */
app_resourceRec app_resources;		/* my private resources */
int ind[256]; 
Display *disp;
Window mywindow;


/******  RESOURCES  ******/

static char default_about[] =
        "This skeleton X11 program was written by Jim Gochee, January 30, 1989.";

static XtResource resources[] = {
    {"about",    "About",    XtRString, sizeof(String),
        XtOffset(app_res,about_msg), XtRString, (caddr_t)default_about},
};


static char defaultTranslations[] = "";

/*
static char defaultTranslations[] = "<Btn1Down>:ButtonDown()\n\
                                    <Expose>:RedrawObject()";
*/

/******  ACTIONS  ******/

static void Null()
{
}



static XtActionsRec null_actions[] = {
	{ "Null",	Null},
        };


/****** MAIN PROGRAM  ******/

setup_window(argc, argv, red, green, blue, width, height)
     int argc;
     char **argv;
     int red[], green[], blue[];
     int width, height;
{
  Arg arg[10];
  int n;
  Widget description,outer, command_box, color_box, pattern_box;
  XtTranslations mytranslations;
  XColor mycolor, add_color;
  Status status;
  Colormap color_map, color_map2;
  int screen, k;
  XSetWindowAttributes attr;
  Visual *visual;
  
  disp = XOpenDisplay(0);
  if (disp == 0) {
    perror("Opening display");
    exit(1);
  }

  screen = XDefaultScreen(disp);

  color_map = DefaultColormap(disp, screen);
  visual = DefaultVisual(disp, screen);

  color_map2 = XCreateColormap(disp, RootWindow(disp, screen), visual, AllocNone);
  
  add_color.flags = DoRed | DoGreen | DoBlue;


  for(k=0; k < 256; k++)
    if (!XAllocColorCells(disp, color_map2, False, NULL, 0, &ind[k], 1))
      printf("DANGER\n");

  for(k=0; k < 256; k++) {
    add_color.red =  red[k] << 8;
    add_color.green = green[k] << 8;
    add_color.blue = blue[k] << 8;
    add_color.pixel = ind[k];
/*    if(!(status = XAllocColor(disp, color_map, &add_color))) */
/*      printf("Failure to allocate a pixel\n"); */
    if (!XStoreColor(disp, color_map2, &add_color))
      printf("BAD\n");
 
/*    ind[k] = add_color.pixel; */
  }

  attr.background_pixel = WhitePixel(disp, screen);
  attr.backing_store = NotUseful;
  attr.save_under = 0;
  attr.event_mask = ExposureMask;
  attr.colormap = color_map; /*color_map2; */

  mywindow = XCreateWindow(disp, RootWindow(disp, screen), 10, 20, width, height, 0, 8, InputOutput, CopyFromParent, 
			   CWBackPixel | CWBackingStore | CWEventMask |
			   CWColormap | CWSaveUnder, &attr);
  XMapWindow(disp, mywindow);
}


void draw_bitmap(pixdata, x, y, width, height)
     void *pixdata;
     int x, y, width, height;
{
  XImage *myimage;
  void *data;
  int screen;
  int value;
  GC gc;
  XGCValues gcv;

  screen = XDefaultScreen(disp);
  myimage = XCreateImage(disp, XDefaultVisual(disp, screen), 8, ZPixmap, 0, pixdata, width, height, 8, 0); 
  myimage->byte_order = MSBFirst;
  
  gcv.function = GXcopy;
  gcv.foreground = 0;
  gc = XCreateGC(disp, mywindow, GCFunction | GCForeground, &gcv);

  XPutImage(disp, mywindow, gc, myimage, 0, 0,x,y, width, height);
}


void draw_pixmap(pixdata, x, y, width, height)
     void *pixdata;
     int x, y, width, height;
{
  int k;

  for(k=0; k < width*height; k++)
    *((unsigned char *) pixdata + k) = (unsigned char) 
      ind[*((unsigned char *) pixdata + k)];
  
  draw_bitmap(pixdata, x, y, width, height);
}


void go_picture(pixdata, width, height, x, y, button)
     void *pixdata;
     int width, height, *x, *y, *button;
{
  XEvent report;
  
  XSelectInput(disp, mywindow, ExposureMask | ButtonPressMask);
  while(1) {
    XNextEvent(disp, &report);
    switch(report.type) {
    case Expose:
      if (report.xexpose.count != 0)
	break;
      draw_bitmap(pixdata, 0, 0, width, height);
      break;
    case ButtonPress:
      *x = report.xbutton.x;
      *y = report.xbutton.y;
      switch(report.xbutton.button) {
      case Button1:
	*button = 1;
	break;
      case Button2:
	*button = 0;
	break;
      case Button3:
	*button = -1;
	break;
      }
      XClearWindow(disp, mywindow);
      return;
    }
  }

/*  XtMainLoop(); */
}
