#include <stdio.h>
#include <sys/types.h>                    /* This is necessary on northstar */
#include <netinet/in.h>                   /* This is necessary on northstar */

/* These include files are necessary for objects */
#include "sockets.h"
#include "spede.h"
#include "spede_io.h"
#include "objects.h"
#include "objlib.h"


char *object_name = "template_obj";          /* This is used to register obj */


/* CALLBACK
 *
 * This is the main callback routine for the object. When an object receives
 * an OBJ_MESSAGE command, this routine will be called to handle the message.
 * The message number is passed in as 'message', parameters to the object are
 * passed in in 'params', and 'r_params' is used to send parameters back to
 * the caller. The underlying mechanism will transport the return paramters and
 * free any memory associated with them when the transfer is complete.
 *
 * The routine also returns a long 'result' value, which is sent to the calling
 * object. Note that it is not necessary to have any return parameters in
 * 'r_params'.
 *
 * The two messages that all objects should pay attention to are "CREATE" and
 * "DELETE". These are predefined constants. CREATE is sent to an object when
 * it is first created, and DELETE is sent just before the object is
 * terminated. NOTE: User message numbers must be greater than 10.
 */
static long callback(message, params, r_params)
     int message;
     parameter_block *params, **r_params;
{
  long result;

  r_params = 0L;
  switch(message) {
  case CREATE:                                 /* Allows object to alloc mem */
    break;
  case DELETE:                                 /* Tell object to shut down */
    break;
/* case user_messages:
   break;
*/
  default:
    printf("Invalid message.\n");
    return(0);
  }
}
  


/* MAIN
 *
 * This main calls two underlying routines for object operation. The user need
 * not put any code in this area. If the object in question is launched from
 * the command line, the routine 'free_launch' will be called.
 */
main(argc, argv) 
     int argc;
     char **argv;
{
  if(init_objects(argc, argv, callback)) {
    perror("Error trying to initialize the object library");
    exit(1);
  }
  register_dean();                      /* Tell local dean we exist */
}


/* FREE_LAUNCH
 * 
 * This routine is called by the object library if the user launched the
 * object from the command line. Some objects should not be launched from the
 * command line and can terminate if this routine is called. Other objects will
 * use routine as if it were 'main'.
 */
void free_launch(int argc, void **argv)
{
}


/* NORMAL_LAUNCH
 *
 * This routine is the counterpart to free_launch. It is called by the object
 * library when the object is launched in response to a 'create_object'
 * command from another object. This routine is given as another place to
 * put initialization code.
 */

void normal_launch()
{
}
